/*************************************************************************
 *
 * Copyright 2009 by bBreak Systems.
 *
 * ExCella Core - Excelt@CJava痘p邽߂̋ʊ
 *
 * $Id: TagParser.java 56 2009-05-21 04:13:39Z yuta-takahashi $
 * $Revision: 56 $
 *
 * This file is part of ExCella Core.
 *
 * ExCella Core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * ExCella Core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the COPYING.LESSER file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with ExCella Core.  If not, see
 * <http://www.gnu.org/licenses/lgpl-3.0-standalone.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/
package org.bbreak.excella.core.tag;

import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Sheet;
import org.bbreak.excella.core.exception.ParseException;
import org.bbreak.excella.core.util.TagUtil;

/**
 * ^ÕX[p[NX
 * 
 * @since 1.0
 *
 * @param <RESULT> ʂ̌^
 */
public abstract class TagParser<RESULT> {
	
	/**
     * p[^`̊Jn
     */
    public static final String TAG_PARAM_PREFIX = "{";

    /**
     * p[^`̏I
     */
    public static final String TAG_PARAM_SUFFIX = "}";

    /**
     * p[^؂蕶
     */
    public static final String PARAM_DELIM = ",";

    /**
     * L[Al̋؂蕶
     */
    public static final String VALUE_DELIM = "=";

    /**
     * ̃p[Tŏ^O
     */
    private String tag;

    /**
     * RXgN^
     * 
     * @param tag Ώۃ^O
     */
    public TagParser( String tag) {
        this.tag = tag;
    }

    /**
     * p[Xsۂ̔
     * 
     * @param sheet ΏۃV[g
     * @param tagCell ΏۃZ
     * @return Ώۂ̏ꍇTrueAΏۊȌꍇFalse
     * @throws ParseException
     */
    public boolean isParse( Sheet sheet, Cell tagCell) throws ParseException {
        // 񂩂A^O܂ރZ̏ꍇ͏Ώ
        if ( tagCell.getCellType() == Cell.CELL_TYPE_STRING) {
            String cellTag = TagUtil.getTag( tagCell.getStringCellValue());
            if ( tag.equals( cellTag)) {
                return true;
            }
        }
        return false;
    }

    /**
     * p[X
     * 
     * @param sheet ΏۃV[g
     * @param tagCell ^O`ꂽZ
     * @param data BookControllerparseBook(), parseSheet()\bhA 
     *              SheetParserparseSheet\bhňnꍇ
     *              TagParser܂ňp鏈f[^
     * @return p[X
     * @throws ParseException p[XO
     */
    public abstract RESULT parse( Sheet sheet, Cell tagCell, Object data) throws ParseException;

    /**
     * Ώۃ^O̎擾
     * 
     * @return Ώۃ^O
     */
    public String getTag() {
        return tag;
    }

    /**
     * Ώۃ^O̐ݒ
     * 
     * @param tag Ώۃ^O
     */
    public void setTag( String tag) {
        this.tag = tag;
    }
}
